/*
Switch shroud for an OS Pixie M1 and M2.
15mm mounting centres

*/

$fn = 100;
difference() {

 union(){
     
    cube ([20,10,1],center=true); //main body
     
    translate ([0,4,2]) { //switch shroud (one side)
     cube ([8,2,4],center=true);
    }
    translate ([0,-4,2]) { //switch shroud (other side)
     cube ([8,2,4],center=true);
    }
//Switch shroud lower part so can add radius
    translate ([0,4,1]) { //switch shroud (one side)
     cube ([12,2,2],center=true);
    }
    translate ([0,-4,1]) { //switch shroud (other side)
     cube ([12,2,2],center=true);
    }

//Radius to the switch shroud
    rotate(a=[90,0,0]) {
     translate ([4,2,4]) { //One end
      cylinder (d=4,h=2,center=true);
     }
    }
    rotate(a=[90,0,0]) {
     translate ([4,2,-4]) { //One end
      cylinder (d=4,h=2,center=true);
     }
    }
    rotate(a=[90,0,0]) {
     translate ([-4,2,4]) { //One end
      cylinder (d=4,h=2,center=true);
     }
    }
    rotate(a=[90,0,0]) {
     translate ([-4,2,-4]) { //One end
      cylinder (d=4,h=2,center=true);
     }
    }

//Main body circular ends
    translate ([10,0,0]) { //One end
     cylinder (d=10,h=1,center=true);
    }
    translate ([-10,0,0]) { //the other circular end
     cylinder (d=10,h=1,center=true);
    }
} //End of "union", the rest is taking bits away!

//The switch cut-out
    cube ([9,5,1.2],center=true);

//The switch mounting hole cut-outs
    translate ([9.5,0,0]) {
     cylinder (d=3,h=1.2,center=true);
    }
    translate ([-9.5,0,0]) {
     cylinder (d=3,h=1.2,center=true);
    }

//The text on the switch to indicate On/Off.
    
    rotate(a=[0,0,90]) { //Turn thro' 90 deg
     translate ([0,13,0]) { //Move towards the end
      //linear_extrude(height = 0.5) {
        linear_extrude(height = 1) { 
        text("I", font = "Arial Rounded MT Bold:style=Regular",     size = 2,halign = "center", valign = "center",center=true);
      }
     }
    }
    rotate(a=[0,0,90]) {
     translate ([0,-13,0]) { //One end
      //linear_extrude(height = 0.5) {
      linear_extrude(height = 1) {    
       text("0", font = "Arial Rounded MT Bold:style=Regular", size = 2, halign = "center", valign = "center",center=true);
      }
     }
    }
}